//
//	ADDefaults.h
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <Foundation/NSObject.h>

#if defined(NX_CURRENT_COMPILER_RELEASE) && NX_CURRENT_COMPILER_RELEASE > 330
#define OPENSTEP 1
#endif
#if defined(NX_CURRENT_COMPILER_RELEASE) && NX_CURRENT_COMPILER_RELEASE >= 500
#define RHAPSODY 1
#endif

@class NSString, NSDictionary, NSArray;

/* NSUserDefaults keys */
extern NSString *ADCopyrightOwner;
extern NSString *ADOutputDirectory;
extern NSString *ADProjectDirectory;
extern NSString *ADParseSingleHeaders;
extern NSString *ADPreserveTree;
extern NSString *ADForceOverwrite;
extern NSString *ADShowTimestamp;
extern NSString *ADRunSilently;
extern NSString *ADCopyDocumentation;
extern NSString *ADDebugLevel;
extern NSString *ADTemplateFilename;
extern NSString *ADDocumentAllClasses;

#ifndef OPENSTEP
extern NSDictionary *defaultDictionary;
#endif

extern BOOL ADBoolForDefault(NSString *defaultName);
extern int ADIntForDefault(NSString *defaultName);
extern NSString *ADStringForDefault(NSString *defaultName);

extern NSArray *ADHandleArguments(int argc, char *argv[]);

