//
//	ADConstant.m
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "ADConstant.h"
#import <Foundation/NSCharacterSet.h>
#import <Foundation/NSArray.h>
#import <Foundation/NSScanner.h>
#import <MiscFoundation.subproj/NSString+MiscAdditions.h>
#import "ADUtilities.h"

@implementation ADConstant

+ constantWithString:(NSString *)string
{
	return [[[self alloc] initWithString:string] autorelease];
}

/*"
 * The designated initializer for ADConstant.  The argument should contain
 * the entire #define statement, from which the name and value is pulled.
"*/
- initWithString:(NSString *)string
{
	NSScanner	*scanner = [NSScanner scannerWithString:string];
	
	[super init];

	[scanner scanUpToString:@"define" intoString:NULL];
	[scanner scanString:@"define" intoString:NULL];
	
	[scanner scanCharactersFromSet:ADVariableNameSet() intoString:&name];
	value = [[string substringFromIndex:[scanner scanLocation]] stringByTrimmingWhitespace];
	
	[name retain];
	[value retain];

	return self;
}

- (void)dealloc
{
	[name release];
	[value release];
	[super dealloc];
}
	
- (NSString *)name
{
	return name;
}

- (NSString *)value
{
	return value;
}

- description
{
	return [NSString stringWithFormat:@"#define %@ %@", name, value];
}


@end
