//
//	ADProtocol.m
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "ADProtocol.h"
#import "ADComment.h"
#import <Foundation/NSString.h>

@implementation ADProtocol

/*"
 * ADProtocol represents an Objective-C protocol.
"*/

/*"
 * Returns a new, autoreleased ADProtocol.
"*/
+ protocol
{
	return [[[self alloc] init] autorelease];
}

- init
{
	[super init];
	[self setDescriptionString:@"No protocol description."];
	return self;
}

- (void)dealloc
{
	[protocolName release];
	[super dealloc];
}

- (void)setProtocolName:(NSString *)aName
{
	[aName retain];
	[protocolName release];
	protocolName = aName;
}

- (NSString *)protocolName
{
	return protocolName;
}

- (NSString *)title
{
	return [self protocolName];
}

- (NSString *)interfaceTitle
{
	return @"Protocol";
}

- (NSString *)uniqueFileBasename
{
	return [NSString stringWithFormat:@"%@Protocol", [self protocolName]];
}

- description
{
	return [NSString stringWithFormat:@"@protocol %@ %@\n%@\n%@",
				protocolName,
				[self conformedProtocolString],
				[self entityDescription],
				[self declarationArray]];
}

@end
